*
* initialize task ranges from level to level
*	acc has type of level
*
	
init_tasktable:		;ninsys has the table
	lda #<task_typetable1
	sta tasktable
	lda #>task_typetable1
	sta tasktable+1
	rtl

*
*	initialize task address tables for this zone
*		acc has type of level
*

inittaskmap:			
	asl a
	tay
	phb
	lda	#22
	pha
	plb
	lda starttasktable,y
	sta taskmaptable
	lda starttasktable+1,y
	sta taskmaptable+1
	plb
	rtl

starttasktable:
	dc.w maptasktable1		;borg
	dc.w maptasktable2		;bug/sand
	dc.w maptasktable3		;ancient
	dc.w maptasktable4		;space
	dc.w maptasktable5		;ultra
	dc.w maptasktable6		;world
	
*
* borg-bug level tasks
*

type_utility	equ 4		;bob's utilities
type_bullet		equ 5		;bullets fired by remote
;type_badbullet	equ 6		;bullets fired by enemy

type_generic	equ 0		;terminal/combination/item backs/explosions

type_spaceship	equ	0		;bob's space ship
type_spacelaser	equ	1		;bob's lasers
type_spacerock	equ	2		;space rocks coming down at bob
type_spacestuff	equ	3		;explosions/debris

space_rockstart	equ	7
space_rockend	equ	17



*
* borg level
*

	
maptasktable1
	dc.w	dummy
	dc.b	1,0
	dc.b	0,0
	dc.b	0

;	1 SINE WAVE SLOW MISSILE		
	dc.w	borgmissiletask		;TASK NAME
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,0					;XOFF,YOFF
	dc.b	7					;BANK #
	
;	2 PATROLLER BORG
	dc.w	borgtask				
	dc.b	type_enemy,borg_start		
	dc.b	0,-32						
	dc.b	7

;	3	BORG SNAKE BOSS HEAD
	dc.w	borgbossheadtask		
	dc.b	type_enemy,0
	dc.b	8,16
	dc.b	7

;	4	BORG SNAKE BOSS TURRET
	dc.w	bossheadguntask			
	dc.b	type_enemy,0
	dc.b	-26-8,14				
	dc.b	7
	
;	5	WALKING BORG TANK DUDE
	dc.w	walkingtanktask			
	dc.b	type_enemy,0
	dc.b	0,-16
	dc.b	7
		
;	6	HIDDEN GUN.  1=CEILING HIDDEN GUN
	dc.w	hiddenguntask			
	dc.b	type_enemy,0
	dc.b	-5,-10
	dc.b	7
	
;	7	FLYING GUN
	dc.w	flyingguntask			
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7
	
;	8	ROMAN CANDLE LAUNCHER
	dc.w	romancandletask		
	dc.b	type_enemy,0
	dc.b	-4,-16
	dc.b	7
	
;	9	HOVERING ZAPPER
	dc.w	hoverzaptask			
	dc.b	type_enemy,0
	dc.b	0,0	
	dc.b	7
	
;	10	BORG SHOOTER - DOESN'T MOVE
	dc.w	borgtask					
	dc.b	type_enemy,borg_shooter
	dc.b	0,-32						
	dc.b	7
	
;	11	CEILING TURRET
	dc.w	turrettask				
	dc.b	type_enemy,0
	dc.b	0,-7
	dc.b	7
	
;	12	BORG mutoid	- ultra		
	dc.w	mutoidbosstask		;armbosstask			
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7
	
;	13	BORG JUMPER
	dc.w	borgtask					
	dc.b	type_enemy,borg_jumper
	dc.b	-4,-32
	dc.b	7
	
;	14	4 WAY FLAME TURRET
	dc.w	fourwaytask				
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7
		
;	15	SIDE WALL TURRET SHOOTING RIGHT
	dc.w	sideturrettask			
	dc.b	type_enemy,0
	dc.b	-9,-16
	dc.b	7
	
	
*
* technology/stuff	-16
*

;	16	HORIZONTAL PLATFORM
	dc.w	horizplatform		;horizontally moving platform
	dc.b	type_walk,0		
	dc.b	12,0
	dc.b	13
	
;	17	ELEVATOR
	dc.w	anelevator	
	dc.b	type_walk,0
	dc.b	11,-19	
	dc.b	13
		
;	18	 POWERUP - MISSILES
	dc.w	storagebox		
	dc.b	type_enemy,5		;missile
	dc.b	0,0	
	dc.b	13
	
;	19	FLOATING BORG MINE
	dc.w	minetask			
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7
	
;	20	WALL TURRET SHOOTING TO LEFT
	dc.w	sideturrettask		
	dc.b	type_enemy,1
	dc.b	1,-16
	dc.b	7
	
;	21	POWERUP - FLAME
	dc.w	storagebox			
	dc.b	type_item,4		
	dc.b	0,0
	dc.b	13	

;	22	POWERUP - SONIC BOOM
	dc.w	storagebox			
	dc.b	type_item,7	
	dc.b	0,0
	dc.b	13
	
;	23	SCOOTER TRIGGER
	dc.w	testscooter		;23 - bob drives
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	1

*
* items and stuff
*	

;	24	POWERUP - LIVES
	dc.w	storagebox		
	dc.b	type_item,0		
	dc.b	0,0
	dc.b	13

;	25	POWERUP - 25 SINGLE SHOT AMMO
	dc.w	storagebox
	dc.b	type_item,2		
	dc.b	0,0
	dc.b	13

;	26	POWERUP - FULL ENERGY
	dc.w	storagebox
	dc.b	type_item,1		;power up
	dc.b	0,0
	dc.b	13	

;	27	REMOTE - STUN BULB
	dc.w	storagebox
	dc.b	type_item,14	;light bulb remote
	dc.b	0,0
	dc.b	13	
		
;	28	POWERUP - PULSE BEAM
	dc.w	storagebox		;pulse beam
	dc.b	type_item,6
	dc.b	0,0
	dc.b	13
	
;	29	REMOTE - TRAMPOLINE
	dc.w	storagebox		;29 - spring remote
	dc.b	type_item,17		
	dc.b	0,0
	dc.b	13
	
;	30	POWERUP - 25 TRIPLE SHOTS
	dc.w	storagebox		;30 - tri-shot
	dc.b	type_item,3		
	dc.b	0,0
	dc.b	13
				
;	31 TRAPDOOR
	dc.w	trapdoor		;31 - trap door
	dc.b	type_walk,0
	dc.b	16,-19
	dc.b	13

;	dc.w	bubblegen			;32 ultra force bubble generator
;	dc.b	type_generic,0
;	dc.b	0,0
;	dc.b	13
	
;	32	BIG SPACESHIP
	dc.w	bigship				;32 - big spaceship
	dc.b	type_enemy,0		;intro.asm
	dc.b	16,32
	dc.b	13

;	33	SPACEPORT BOSS - WHO THE FUCK IS THIS?
	dc.w	bossguy				;33 - screen lock task
	dc.b	type_enemy,0
	dc.b	16,0
	dc.b	0
	
	
;34 -scooter mine
	dc.w	scootermines
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	12
	
;	35	REMOTE - SHIELD
	dc.w	storagebox		;35 - shield remote
	dc.b	type_item,15		
	dc.b	0,0
	dc.b	13
	
;	36	REMOTE - COPTER
	dc.w	storagebox		;36 - copter remote
	dc.b	type_item,18		
	dc.b	0,0
	dc.b	13	

;	37	REMOTE - BERZERKER (N/A)
	dc.w	storagebox		;37 - bezerker remote
	dc.b	type_item,19		
	dc.b	0,0
	dc.b	13		

;	38	DROP-AWAY PLATFORM
	dc.w	droppingplatform	
	dc.b	type_walk,0		
	dc.b	-4,0
	dc.b	13
	
;	39	RIGHT GAS JET
	dc.w	gasjettask	
	dc.b	type_enemy,0		
	dc.b	8,-7
	dc.b	7
	
;	40	DOWN GAS JET
	dc.w	gasjettask	
	dc.b	type_enemy,1		
	dc.b	-11,13
	dc.b	7
	
;	41	UP GAS JET
	dc.w	gasjettask	
	dc.b	type_enemy,3
	dc.b	0,0
	dc.b	7
	
;	42	LEFT GAS JET
	dc.w	gasjettask	
	dc.b	type_enemy,2		
	dc.b	-20,-8
	dc.b	7

;	43	HIDDEN GUN.  1=CEILING HIDDEN GUN
	dc.w	hiddenguntask			
	dc.b	type_enemy,1
	dc.b	-5,16
	dc.b	7

;	44 fast  MISSILE		
	dc.w	fastmissiletask		;TASK NAME
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,0					;XOFF,YOFF
	dc.b	7					;BANK #
	

;	45	BIG SPACESHIP #2
	dc.w	screenliftertask	;45 - screen lifter task
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7


; 46 STORAGE BOX

	dc.w	storagebox			;46 - parachute
	dc.b	type_enemy,16		
	dc.b	0,0
	dc.b	13
	
;	47	HORIZONTAL PLATFORM
	dc.w	vertplatform		;horizontally moving platform
	dc.b	type_walk,0		
	dc.b	-8,0
	dc.b	13	
	
;48 -victory
	dc.w	teleportswirl			
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	13	
	
;49	BORG ducks and stands - DOESN'T MOVE
	dc.w	borgtask					
	dc.b	type_enemy,borg_ducker	
	dc.b	0,-32						
	dc.b	7

*
* bug/sand stuff
*

maptasktable2

	dc.w	dummy
	dc.b	1,0
	dc.b	0,0
	dc.b	0

	dc.w	sandcrabtask		;sandwormtask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,-21						;XOFF,YOFF
	dc.b	7

	dc.w	sandcrabtask				;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,-21						;XOFF,YOFF
	dc.b	7

	dc.w	workertask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	-8,-24					;XOFF,YOFF
	dc.b	7

	dc.w	scorpiontask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,-21					;XOFF,YOFF
	dc.b	7

	dc.w	wasptask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,8						;XOFF,YOFF
	dc.b	7

	dc.w	roachtask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,8					;XOFF,YOFF
	dc.b	7

	dc.w	rolypolytask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,16					;XOFF,YOFF
	dc.b	7

	dc.w	eggtask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,-24						;XOFF,YOFF
	dc.b	7

	dc.w	eggtask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,0						;XOFF,YOFF
	dc.b	7

	dc.w	droppertask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	-8,-8						;XOFF,YOFF
	dc.b	7

	dc.w	queentask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	8,-10						;XOFF,YOFF
	dc.b	7

	dc.w	flytask					;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,-24						;XOFF,YOFF
	dc.b	7

	dc.w	wasptask			;was hwasp		;TASK
	dc.b	type_enemy,0		;TASK RANGE, PICLOGIC
	dc.b	0,-24						;XOFF,YOFF
	dc.b	7
	
	dc.w	storagebox			;14 - ammo
	dc.b	type_enemy,2		
	dc.b	0,0
	dc.b	13
	
	dc.w	storagebox			;15 - flame
	dc.b	type_enemy,4		
	dc.b	0,0
	dc.b	13	
	
	dc.w	storagebox			;16 - juice
	dc.b	type_enemy,1		
	dc.b	0,0
	dc.b	13

	dc.w	storagebox			;17 - spring remote
	dc.b	type_enemy,17		
	dc.b	0,0
	dc.b	13
	
	dc.w	storagebox			;18 - tri-shot
	dc.b	type_enemy,3		
	dc.b	0,0
	dc.b	13
	
	dc.w	storagebox			;19 - flyin gun
	dc.b	type_enemy,14		
	dc.b	0,0
	dc.b	13
	
	dc.w	storagebox			;20 - life
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	13
	
	dc.w	wasptask			;21 - sine wasps
	dc.b	type_enemy,1		
	dc.b	0,8						
	dc.b	7

	dc.w	droppertask			;22 moving dropper
	dc.b	type_enemy,1		;TASK RANGE, PICLOGIC
	dc.b	-8,-8						;XOFF,YOFF
	dc.b	7
	
	dc.w	workertask			;23 jumping worker
	dc.b	type_enemy,1		;TASK RANGE, PICLOGIC
	dc.b	-8,-24					;XOFF,YOFF
	dc.b	7
	
	dc.w	storagebox			;24 - bomb remote
	dc.b	type_enemy,17		
	dc.b	0,0
	dc.b	13
	
	dc.w	bossguy				;25 - scroll lock
	dc.b	type_enemy,0
	dc.b	16,0
	dc.b	0
	
	dc.w	storagebox			;26 - copter
	dc.b	type_enemy,18		
	dc.b	0,0
	dc.b	13

;27 -victory
	dc.w	teleportswirl			
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	13	

;28 fly swarms
	dc.w	flyswarmtask		
	dc.b	type_enemy,0	
	dc.b	0,8				
	dc.b	7

;29 - missiles
	dc.w	storagebox			
	dc.b	type_enemy,5		
	dc.b	0,0
	dc.b	13	

*
* level 3	- ancient level
*

maptasktable3

	dc.w	dummy
	dc.b	1,0
	dc.b	0,0
	dc.b	0
	
	dc.w	druidtask
	dc.b	type_enemy,0	
	dc.b	0,-30
	dc.b	7

	dc.w	powerorbtask
	dc.b	type_enemy,2		
	dc.b	0,0
	dc.b	7

	dc.w	skulltask
	dc.b	type_enemy,2		
	dc.b	0,-16
	dc.b	7

	dc.w	handtask
	dc.b	type_enemy,2		
	dc.b	0,0
	dc.b	7

	dc.w	spheretask
	dc.b	type_enemy,2		
	dc.b	-4,-8
	dc.b	7
 
    dc.w	powerorbtask			;ghosttask
	dc.b	type_enemy,2		
	dc.b	0,0
	dc.b	7
	
	dc.w	lavamantask
	dc.b	type_enemy,2		
	dc.b	0,-13
	dc.b	7
	
	dc.w	imptask
	dc.b	type_enemy,2		
	dc.b	0,0
	dc.b	7

;	11 		PUNCHING POTATOHEAD	
	dc.w	statuetask
	dc.b	type_enemy,2		
	dc.b	0,-8
	dc.b	7
	
;	10		LAVA BUBBLE
	dc.w	lavabubbletask
	dc.b	type_enemy,2		
	dc.b	-8,0
	dc.b	7
	
;	11		POWERUP - FULL ENERGY JUICEUP WITH FROMOSA
	dc.w	storagebox			;11 - juice
	dc.b	type_enemy,1		
	dc.b	0,0
	dc.b	13

;	12		POWERUP - PLASMA BEAM
	dc.w	storagebox			;12 - energy beam
	dc.b	type_enemy,6		
	dc.b	0,0
	dc.b	13
	
;	13		REMOTE - COPTER
	dc.w	storagebox			;13 - copter
	dc.b	type_enemy,18
	dc.b	0,0
	dc.b	13
	
;	14		VOLCANO	
	dc.w	volcanotask
	dc.b	type_enemy,2		
	dc.b	-8,0
	dc.b	7
	
;	15
	dc.w	storagebox			;15 - life
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	13
	
;	16	GRAVITY ON
	dc.w	dummy
	dc.b	type_enemy,1
	dc.b	0,0
	dc.b	0
	
;	17	CRUSHING WALL TIMER 1
	dc.w	crushingwall		;17
	dc.b	type_enemy,0
	dc.b	-5,47
	dc.b	2
	
;	18	CRUSHING WALL TIMER 2
	dc.w	crushingwall
	dc.b	type_enemy,1
	dc.b	-5,47
	dc.b	2	
	
;	19	BOW AND ARROWS
	dc.w	bowtask
	dc.b	type_enemy,1	
	dc.b	0,8
	dc.b	7
	
;	20	SHADOW MAN
	dc.w	shadowmantask
	dc.b	type_enemy,2		
	dc.b	0,16
	dc.b	7
	
;	21	WIERD EYE SPITTING ANCIENT BOSS
	dc.w	fatheadtask
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	7

;	22	PLANET TYPE 1
	dc.w	planettask
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	7

;	23	PLANET TYPE 2
	dc.w	planettask
	dc.b	type_enemy,1		
	dc.b	0,0
	dc.b	7

;	24	REMOTE  - SHIELD
	dc.w	storagebox
	dc.b	type_enemy,15		
	dc.b	0,0
	dc.b	13

;	25	GOLD BALLS DOWN
	dc.w	goldballtask
	dc.b	type_enemy,1		
	dc.b	0,-8
	dc.b	7

;	26	GOLD BALLS UP
	dc.w	goldballtask
	dc.b	type_enemy,0		
	dc.b	0,8
	dc.b	7

;	27	PLANET TYPE 3
	dc.w	planettask
	dc.b	type_enemy,2		
	dc.b	0,0
	dc.b	7

;	28	LAVABOSS
	dc.w	lavabosstask
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	7

;	29	LOCKSCREEN TASK
	dc.w	planettask
	dc.b	type_enemy,2		
	dc.b	0,0
	dc.b	7

;	30	FIRE VOMIT FROM STATUES
	dc.w	planettask
	dc.b	type_enemy,2		
	dc.b	0,0
	dc.b	7

;	31	SCROLL LOCK
	dc.w	bossguy				;31 - scroll lock
	dc.b	type_enemy,0
	dc.b	16,0
	dc.b	0

;	32	REMOTE - TRAMPOLINE
	dc.w	storagebox		;32 - spring remote
	dc.b	type_item,17		
	dc.b	0,0
	dc.b	13
	
;	33	POWERUP - 25 TRIPLE SHOTS
	dc.w	storagebox		;33 - tri-shot
	dc.b	type_item,3		
	dc.b	0,0
	dc.b	13
	
;34 - parachute

	dc.w	storagebox			;2 - parachute
	dc.b	type_enemy,16		
	dc.b	0,0
	dc.b	13
	
;35 - crumbling platform

	dc.w	crumblingplatform	;crumbling platform
	dc.b	type_walk,0		
	dc.b	-2,0
	dc.b	13

;36	- FALLING BRICK

	dc.w	fallingbricktask
	dc.b	type_enemy,0		
	dc.b	-4,0
	dc.b	7
	
;37 - sonic

	dc.w	storagebox			
	dc.b	type_enemy,7		
	dc.b	0,0
	dc.b	13

;38 - bezerker
	dc.w	storagebox			
	dc.b	type_enemy,19		
	dc.b	0,0
	dc.b	13
		
;39 - stun remote
	dc.w	storagebox			
	dc.b	type_enemy,14		
	dc.b	0,0
	dc.b	13

;40 - missiles
	dc.w	storagebox			
	dc.b	type_enemy,5		
	dc.b	0,0
	dc.b	13

;41 -victory
	dc.w	teleportswirl			
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	13	

;42 - ancient boss
	dc.w	armbosstask			
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	7	

;43
	dc.w	storagebox			
	dc.b	type_enemy,2		
	dc.b	0,0
	dc.b	13	

;44							;FALLING lava/ancient FIREBALLS
	dc.w	fireballtask
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	7
	
*
*  space level
*

maptasktable4
	; bye bye
	
*
* ultra force task list
*

maptasktable5
	dc.w	dummy
	dc.b	1,0
	dc.b	0,0
	dc.b	0

	dc.w	bubblegen			;1 ultra force bubble generator
	dc.b	type_enemy,0
	dc.b	-22,-4
	dc.b	13
	
	dc.w	storagebox			;2 - parachute
	dc.b	type_enemy,16		
	dc.b	0,0
	dc.b	13

	dc.w	windgenerator		;3blow left
	dc.b	type_enemy,1
	dc.b	-22,0
	dc.b	13
	
	dc.w	windgenerator
	dc.b	type_enemy,0		;4blow up
	dc.b	0,-20
	dc.b	13
	
	dc.w	windgenerator
	dc.b	type_enemy,2		;5blow right
	dc.b	18,0
	dc.b	13
	
	dc.w	storagebox			;6life
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	13


;	7	DROP-AWAY PLATFORM
	dc.w	crumblingplatform	;crumbling platform
	dc.b	type_walk,0		
	dc.b	-2,0
	dc.b	13

;	8	HORIZONTAL PLATFORM
	dc.w	horizplatform	
	dc.b	type_walk,0		
	dc.b	-2,0
	dc.b	13
	
;	9	vertical PLATFORM
	dc.w	vertplatform	
	dc.b	type_walk,0		
	dc.b	-2,0
	dc.b	13

;	10	BUBBLE MAN - walking
	dc.w	bubblemantask			;1 ultra force bubble generator
	dc.b	type_enemy,0
	dc.b	0,-8
	dc.b	7
	
;	11	SHROOM
	dc.w	shroomtask			;1 ultra force bubble generator
	dc.b	type_enemy,0
	dc.b	0,8
	dc.b	7

;	12   donuts pattern 1
	dc.w	donuttask			;angle loop
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7
	
;	13   donuts pattern 2
	dc.w	donuttask			;vertical sine wave
	dc.b	type_enemy,1
	dc.b	0,0
	dc.b	7
	
;	14   donuts pattern 3
	dc.w	donuttask			;horiz. sine wave
	dc.b	type_enemy,2
	dc.b	0,0
	dc.b	7

;	15	ROTTEN FRUIT DROPPER
	dc.w	dropperballtask			
	dc.b	type_enemy,0
	dc.b	0,16
	dc.b	7

;	16	HAPPY FUN BALL RAIN
	dc.w	stormtask			
	dc.b	type_enemy,1
	dc.b	0,0
	dc.b	7

;	17	VENUS FLYTRAP grab only
	dc.w	venustask			
	dc.b	type_enemy,0
	dc.b	12,-24
	dc.b	7

;	18	TREE TURRET FIRE LEFT
	dc.w	treeturrettask			
	dc.b	type_enemy,0
	dc.b	-15,-6
	dc.b	7

;	19	TREE TURRET FIRE RIGHT
	dc.w	treeturrettask			
	dc.b	type_enemy,1
	dc.b	4,-6
	dc.b	7

;	20	VENUS FLYTRAP shooter and grabber
	dc.w	venustask			
	dc.b	type_enemy,0
	dc.b	12,-24
	dc.b	7
	
;	21	BUBBLE MAN - throwing
	dc.w	bubblemantask			
	dc.b	type_enemy,0
	dc.b	0,-8
	dc.b	7
	
;	22	 POWERUP - SINGLE SHOT
	dc.w	storagebox		
	dc.b	type_enemy,2		;missile
	dc.b	0,0	
	dc.b	13
	
;	23	 POWERUP - TRIPLESHOT
	dc.w	storagebox		
	dc.b	type_enemy,3		;missile
	dc.b	0,0	
	dc.b	13
	
;	24	 POWERUP - FLAME
	dc.w	storagebox		
	dc.b	type_enemy,4		;missile
	dc.b	0,0	
	dc.b	13
	
;	25	 POWERUP - MISSILE
	dc.w	storagebox		
	dc.b	type_enemy,5		;missile
	dc.b	0,0	
	dc.b	13
	
;	26	 POWERUP - PULSE
	dc.w	storagebox		
	dc.b	type_enemy,6		;missile
	dc.b	0,0	
	dc.b	13
	
;	27	 POWERUP - SONIC BOOOOM
	dc.w	storagebox		
	dc.b	type_enemy,7		;missile
	dc.b	0,0	
	dc.b	13
	
;	28	 REMOTE - STUN REMTOE
	dc.w	storagebox		
	dc.b	type_enemy,14		;missile
	dc.b	0,0	
	dc.b	13
	
;	29	 REMOTE - SHIELD
	dc.w	storagebox		
	dc.b	type_enemy,15		;missile
	dc.b	0,0	
	dc.b	13
	
;	30	 REMOTE - SPRING
	dc.w	storagebox		
	dc.b	type_enemy,17		;missile
	dc.b	0,0	
	dc.b	13
	
;	31	 REMOTE - PARACHUTE
	dc.w	storagebox		
	dc.b	type_enemy,16		;missile
	dc.b	0,0	
	dc.b	13
	
;	32	 REMOTE - COPTER
	dc.w	storagebox		
	dc.b	type_enemy,18		;missile
	dc.b	0,0	
	dc.b	13
	
;	33	 REMOTE - SMARTBOMB
	dc.w	storagebox		
	dc.b	type_enemy,19		;missile
	dc.b	0,0	
	dc.b	13
	
;	34	 POWERUP - JUICE
	dc.w	storagebox		
	dc.b	type_enemy,1		;missile
	dc.b	0,0	
	dc.b	13
	
;	35	 POWERUP - EXTRA LIFE
	dc.w	storagebox		
	dc.b	type_enemy,0		;missile
	dc.b	0,0	
	dc.b	13

;	36	FISH JUMPER
	dc.w	fishtask			
	dc.b	type_enemy,0
	dc.b	0,-4
	dc.b	7

;	37	JELLY CELL 
	dc.w	jellytask			
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7
	
;	38	LAMPREY EEL - THEY'RE EELY GOOD
	dc.w	eeltask			
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7
	
;	39	CELL CLUSTER FUCK
	dc.w	clustertask			
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7
	
;	40	PUSSMINE
	dc.w	pussminetask			
	dc.b	type_enemy,1
	dc.b	0,0
	dc.b	7
	
;	41	LADDER MENACE
	dc.w	menacetask			
	dc.b	type_enemy,0
	dc.b	-4,0
	dc.b	7
	
;	42	CEILING PUSSDROPPER
	dc.w	pussdroppertask			
	dc.b	type_enemy,40
	dc.b	0,-5
	dc.b	7
	
;	43	CELLMAN
	dc.w	cellmantask				;pussdroppertask			
	dc.b	type_enemy,0
	dc.b	0,-12
	dc.b	7

;	44	UFORCE BOSSOLA
	dc.w	pussdroppertask			
	dc.b	type_enemy,40
	dc.b	0,0
	dc.b	7

;	45	HORIZONTAL NERVE PULSE
	dc.w	gasjettask	
	dc.b	type_enemy,4		
	dc.b	8,0
	dc.b	7
	
;	46	VERTICAL NERVE PULSE
	dc.w	gasjettask	
	dc.b	type_enemy,5		
	dc.b	0,16
	dc.b	7

;	47	 screen lock
	dc.w	bossguy				
	dc.b	type_enemy,0
	dc.b	16,0
	dc.b	0
	
;	48 pussman
	dc.w	pussmantask
	dc.b	type_enemy,5		
	dc.b	0,16
	dc.b	7
	
;	49	mutoid men		
	dc.w	mutoidbosstask		;armbosstask			
	dc.b	type_enemy,0
	dc.b	0,0
	dc.b	7
	
;50 -victory
	dc.w	teleportswirl			
	dc.b	type_enemy,0		
	dc.b	0,0
	dc.b	13	

;	51	PUSS TURRET RIGHT
	dc.w	pussturrettask			
	dc.b	type_enemy,0				
	dc.b	-12,0
	dc.b	7

;	52	PUSS TURRET DOWN
	dc.w	pussturrettask			
	dc.b	type_enemy,1				
	dc.b	0,0
	dc.b	7

;	53	PUSS TURRET LEFT
	dc.w	pussturrettask			
	dc.b	type_enemy,2				
	dc.b	4,0				;fire left
	dc.b	7

;	54 	PUSS TURRET UP
	dc.w	pussturrettask			
	dc.b	type_enemy,3				
	dc.b	-4,-12
	dc.b	7
	
;	55 	PUSS VOLCANO
	dc.w	pussvolcanotask			
	dc.b	type_enemy,30				
	dc.b	0,-12
	dc.b	7
	
; 	56	WIND GENERATOR
	dc.w	windgenerator
	 dc.b	type_enemy,3		;5blow down
	dc.b	0,20
	dc.b	13	
	
;	57 virus boss - final boss
	dc.w	virustask
	dc.b	type_enemy,5		
	dc.b	0,16
	dc.b	7
	
	
*
* world map ask list
*

maptasktable6
	dc.w	dummy
	dc.b	1,0
	dc.b	0,0
	dc.b	0
		
*
* world 1 tasks
*
 

	dc.w	building			;1 borg dome
	dc.b	type_enemy,0
	dc.b	-16,-22
	dc.b	10
	
	dc.w	bughole				;2 bug hole
	dc.b	type_enemy,1
	dc.b	-19,-18
	dc.b	10
	
	dc.w	building			;3 borg dome
	dc.b	type_enemy,2
	dc.b	-32,-16
	dc.b	10
	
	dc.w	bughole				;4 bug hole
	dc.b	type_enemy,3
	dc.b	-24,-16
	dc.b	10
	
	dc.w	building			;5 borg dome
	dc.b	type_enemy,4
	dc.b	-32,-32
	dc.b	10

	dc.w	bughole				;6 bug hole
	dc.b	type_enemy,5
	dc.b	-23,-15
	dc.b	10
	
	dc.w	building			;7 borg dome
	dc.b	type_enemy,6
	dc.b	-4,-8
	dc.b	10
	
	dc.w	bughole				;8 bug hole
	dc.b	type_enemy,7
	dc.b	-24,-16
	dc.b	10
	
	dc.w	building			;9 borg dome
	dc.b	type_enemy,8
	dc.b	-36,-12
	dc.b	10
	
	dc.w	building			;10 borg dome
	dc.b	type_enemy,9
	dc.b	-36,-16
	dc.b	10
	
	dc.w	bughole				;11 bug hole
	dc.b	type_enemy,10
	dc.b	-24,-16
	dc.b	10
	
	dc.w	building			;12 borg dome
	dc.b	type_enemy,11
	dc.b	-24,-12
	dc.b	10
	
	dc.w	bughole				;13 bug hole
	dc.b	type_enemy,12
	dc.b	8,-16
	dc.b	10
	
	dc.w	building			;14 borg dome
	dc.b	type_enemy,13
	dc.b	-16,-16
	dc.b	10	
	
	
*
* world 2
*

	dc.w	pyramid				;15 ancient pyramid
	dc.b	type_enemy,0
	dc.b	-16,-8
	dc.b	10	
	
	dc.w	building2			;16 borg 2
	dc.b	type_enemy,1
	dc.b	-16,-16
	dc.b	10	
	
	dc.w	volcanoe			;17 lava
	dc.b	type_enemy,2
	dc.b	-24,-2
	dc.b	10	

	dc.w	pyramid				;18 ancient pyramid
	dc.b	type_enemy,3
	dc.b	4,4
	dc.b	10	
	
	dc.w	building2			;19 borg 2
	dc.b	type_enemy,4
	dc.b	0,-8
	dc.b	10	
	
	dc.w	volcanoe			;20 lava
	dc.b	type_enemy,5
	dc.b	-21,-2
	dc.b	10	
	
	dc.w	building2			;21 borg 2
	dc.b	type_enemy,6
	dc.b	8,-16
	dc.b	10

	dc.w	pyramid				;22 ancient pyramid
	dc.b	type_enemy,7
	dc.b	10,0
	dc.b	10	
	
	dc.w	volcanoe			;23 lava
	dc.b	type_enemy,8
	dc.b	-25,0
	dc.b	10

	dc.w	building2			;24 borg 2
	dc.b	type_enemy,9
	dc.b	-8,-8
	dc.b	10	
	
	dc.w	pyramid				;25 ancient pyramid
	dc.b	type_enemy,10
	dc.b	-8,-4
	dc.b	10	
			
	dc.w	pyramid				;26 ancient pyramid
	dc.b	type_enemy,11
	dc.b	-8,-8
	dc.b	10	
	
	dc.w	building2			;27 borg 2
	dc.b	type_enemy,12
	dc.b	-16,-18
	dc.b	10	
	
	dc.w	pyramid				;28 ancient pyramid
	dc.b	type_enemy,13
	dc.b	-8,-2
	dc.b	10	
	
	dc.w	volcanoe			;29 lava
	dc.b	type_enemy,14
	dc.b	-34,-34
	dc.b	10
	
	dc.w	building2			;30 borg 2
	dc.b	type_enemy,15
	dc.b	-8,-8
	dc.b	10	
	
	dc.w	pyramid				;31 ancient pyramid
	dc.b	type_enemy,16
	dc.b	0,-4
	dc.b	10	
	
	dc.w	building2			;32 borg 2
	dc.b	type_enemy,17
	dc.b	-16,-16
	dc.b	10	
		
	dc.w	building2			;33 borg 2
	dc.b	type_enemy,18
	dc.b	-16,0
	dc.b	10	
	
	
*
* world 3
*
	
	dc.w	theultraforce		;34 ultra
	dc.b	type_enemy,0
	dc.b	-22,-4
	dc.b	10
	
	dc.w	building3			;35 borg 3
	dc.b	type_enemy,1
	dc.b	-8,-8
	dc.b	10	
	
	dc.w	intothetrees		;36 trees
	dc.b	type_enemy,2
	dc.b	-16,-8
	dc.b	10	

	dc.w	theultraforce		;37 ultra
	dc.b	type_enemy,3
	dc.b	-37,-20
	dc.b	10
	
	dc.w	intothetrees		;38 trees
	dc.b	type_enemy,4
	dc.b	0,0
	dc.b	10	
	
	dc.w	theultraforce		;39 ultra
	dc.b	type_enemy,5
	dc.b	-37,5
	dc.b	10

	dc.w	building3			;40 borg 3
	dc.b	type_enemy,6
	dc.b	0,-10
	dc.b	10	
	
	dc.w	intothetrees		;41 trees
	dc.b	type_enemy,7
	dc.b	-24,-12
	dc.b	10	
	
	dc.w	theultraforce		;42 ultra
	dc.b	type_enemy,8
	dc.b	-12,-7
	dc.b	10

	dc.w	building3			;43 borg 3
	dc.b	type_enemy,9
	dc.b	0,-10
	dc.b	10	
	
	dc.w	theultraforce		;44 ultra
	dc.b	type_enemy,10
	dc.b	-21,0
	dc.b	10

	dc.w	theultraforce		;45 ultra
	dc.b	type_enemy,11
	dc.b	-31,0
	dc.b	10
	
	dc.w	building3			;46 borg 3
	dc.b	type_enemy,12
	dc.b	8,-12
	dc.b	10	
	
	dc.w	building3			;47 borg 3
	dc.b	type_enemy,13
	dc.b	-6,-10
	dc.b	10	
	
	dc.w	theultraforce		;48 ultra
	dc.b	type_enemy,14
	dc.b	-15,0
	dc.b	10

	dc.w	theultraforce		;49 ultra
	dc.b	type_enemy,15
	dc.b	-6,-38
	dc.b	10	
	
	dc.w	building3			;50 borg 3
	dc.b	type_enemy,16
	dc.b	-32,-12
	dc.b	10	
	
	
;----------------------------------------------------------------------------------
*
*	
*

spritedma:		;transfer a block of data into the sprite set
;--------
				;copies one line at a time for N vblank cycles
				
	phb
	lda	#22
	pha
	plb
				
				
	lda sdmaflag
	and #1
	beq @initsdma		;if an even #, update process
	plb
	rtl					;odd so exit
	
@initsdma	
	lda	sdmaflag		;eddie baby
	sta	invensdma
	
	lda sdmacount
	bne @keepgoing			;already started?
	
	lda sdmaflag			;set addrs once only per changeover
	asl a
	asl a
	tay						;8 bytes per entry
	
	lda sdma_data,y			;set initial destination
	sta svramaddr
	lda sdma_data+1,y
	sta svramaddr+1
	
	lda sdma_data+2,y		;set source
	sta sdma_addr
	lda sdma_data+3,y
	sta sdma_addr+1
	
	lda sdma_data+4,y
	sta sdma_bank			;source bank
	
	lda sdma_data+5,y
	sta sdma_max			;number of lines to copy

	lda sdma_data+6,y
	sta sdma_size			;set line width lo
	lda sdma_data+7,y
	sta sdma_size+1			;set line width high
	
@keepgoing:
		
	lda	svramaddr			;set current VRAM destination
	sta	VMADDL
	lda	svramaddr+1
	sta	VMADDH
		
	lda	#%00000001
	sta	$4300			; dma mode			
	lda	#<VMDATAWL		; which channel for DMA
	sta	$4301			; b-bus addr

	lda	sdma_bank		
	sta	$4304			; bank #
	lda	sdma_addr		;anim data lo
	sta	$4302			; a-bus low addr
	lda	sdma_addr+1		;anim data hi
	sta	$4303			; a-bus high addr
	
	lda sdma_size
	sta	$4305			; # of bytes low
	lda sdma_size+1
	sta	$4306			; # of bytes high

	lda	#1
	sta	MDMAEN		; turn on dma


		;update data pointers
		
		
	inc sdmacount
	lda sdmacount
	cmp sdma_max			;max lines to copy
	bcs @donetech
	
	
	inc svramaddr+1		;inc dest addr by one row
	
	
	SET16
	
	lda sdma_addr			;inc source
	clc
	adc sdma_size
	sta sdma_addr
	
	SET8

	plb
	rtl
	
@donetech:
	inc sdmaflag
	stz sdmacount
	
	plb
	rtl
	
;-------------------------------------------
; 	SDMA DATA FORMAT: 8 bytes/entry
;
;	destination (upper left)
;	source
;	source bank #
;	# of lines to download (1 line per cycle)
;	bytes per line (lo, hi)
;

sdma_data:

;	0 screaming hand

	dc.w	$4000+(256*16)			;dest
	dc.w	handobj0				;source
	dc.b	abank						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line
	
;	2 crushing skull

	dc.w	$4000+(256*16)			;dest
	dc.w	headobj0				;source
	dc.b	abank						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line

;	4 giant sphere

	dc.w	$4000+(256*16)			;dest
	dc.w	ballobj0				;source
	dc.b	abank						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line
	
;	6 ghost

	dc.w	$4000+(256*16)			;dest
	dc.w	ghosobj0				;source
	dc.b	abank						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line

;	8 shaker statue

	dc.w	$4000+(256*16)			;dest
	dc.w	shakobj0				;source
	dc.b	abank						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line

;	10 fire imp

	dc.w	$4000+(256*16)			;dest
	dc.w	impsobj0				;source
	dc.b	abank						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line
	
; 	12 hovering borg zapper gun	

	dc.w	$4000+(256*16)			;dest
	dc.w	hoveobj					;source
	dc.b	14						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line

; 	14 borg boss snakehead 	

	dc.w	$4000+(256*16)			;dest
	dc.w	snakeobj				;source
	dc.b	14						;bank		
	dc.b	16					;# of lines
	dc.w	512					;bytes/line

; 	16 borg weapons set 1	

	dc.w	$4000+(480*16)			;dest
	dc.w	borgbullet1obj			;source
	dc.b	14						;bank		
	dc.b	2						;# of lines
	dc.w	512						;bytes/line

; 	18 borg weapons set 2

	dc.w	$4000+(480*16)			;dest
	dc.w	borgbullet2obj			;source
	dc.b	14						;bank		
	dc.b	2						;# of lines
	dc.w	512						;bytes/line
	
; 	20 elevator 	

	dc.w	$4000+(256*16)			;dest
	dc.w	elevobj0				;source
	dc.b	4						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line

; 	22 mutoid boss

	dc.w	$4000+(160*16)			;dest
	dc.w	mutoidobj				;source
	dc.b	mutoidbank				;bank		
	dc.b	22						;# of lines
	dc.w	512						;bytes/line
	
; 	24 4 way fire turret

	dc.w	$4000+(256*16)			;dest
	dc.w	fourwayobj					;source
	dc.b	14						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line

; 	26 ancient eye spitter task	

	dc.w	$4000+(160*16)			;dest
	dc.w	mouthobj					;source
	dc.b	10						;bank		
	dc.b	22						;# of lines
	dc.w	512						;bytes/line

;	28 planet attack group

	dc.w	$4000+(256*16)			;dest
	dc.w	planetobj				;source
	dc.b	10					;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line

;	30 shadow man

	dc.w	$4000+(256*16)			;dest
	dc.w	shadowobj				;source
	dc.b	10						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line

;	32 virus death bits	

	dc.w	$4000+(416*16)			;dest
	dc.w	virusdeathobj			;source
	dc.b	10						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/lin
	
;	34 virus boss part 2 - growing frames

	dc.w	$4000+(160*16)			;dest
	dc.w	virus2obj				;source
	dc.b	14						;bank		
	dc.b	20						;# of lines
	dc.w	512						;bytes/line

;	36 virus boss part 3 - attacker frames

	dc.w	$4000+(352*16)			;dest
	dc.w	virus3obj				;source
	dc.b	14						;bank		
	dc.b	10						;# of lines
	dc.w	512						;bytes/line
	
; 	38 uf bubble 	

	dc.w	$4000+(256*16)			;dest
	dc.w	bubbleobj				;source
	dc.b	12						;bank		
	dc.b	4						;# of lines
	dc.w	512						;bytes/line

; 	40 bad sprites after rezin 	

	dc.w	$4000+(160*16)			;dest
	dc.w	0						;source
	dc.b	$7f						;bank		
	dc.b	22						;# of lines
	dc.w	512						;bytes/line

; 	42 rezin sprites 	

	dc.w	$4000+(160*16)			;dest
	dc.w	rezobj0					;source
	dc.b	31						;bank		
	dc.b	22						;# of lines
	dc.w	512						;bytes/line

;	44 arm boss part 1 (bulk of it)

	dc.w	$4000+(160*16)			;dest
	dc.w	0				;source
	dc.b	armbank					;bank		
	dc.b	22						;# of lines
	dc.w	512						;bytes/line
	
;	46 arm boss head part

	dc.w	$4000+(256*16)			;dest
	dc.w	0				;source
	dc.b	armbank					;bank		
	dc.b	6						;# of lines
	dc.w	512						;bytes/line

;	48 bob talk 1

	dc.w	$4000+(80*16)			;dest
	dc.w	bobtalk1				;source
	dc.b	11						;bank		
	dc.b	5						;# of lines
	dc.w	512-64					;bytes/line

;	50 get remotes back

	dc.w	$4000+(80*16)			;dest
	dc.w	remoteobj				;source
	dc.b	1						;bank		
	dc.b	5						;# of lines
	dc.w	(32*14)					;bytes/line

